import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ClinicDoctorUser, ClinicDoctorUserParam } from './model';

/**
 * 分页查询分销商用户记录表
 */
export async function pageClinicDoctorUser(params: ClinicDoctorUserParam) {
  const res = await request.get<ApiResult<PageResult<ClinicDoctorUser>>>(
    '/clinic/clinic-doctor-user/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询分销商用户记录表列表
 */
export async function listClinicDoctorUser(params?: ClinicDoctorUserParam) {
  const res = await request.get<ApiResult<ClinicDoctorUser[]>>(
    '/clinic/clinic-doctor-user',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加分销商用户记录表
 */
export async function addClinicDoctorUser(data: ClinicDoctorUser) {
  const res = await request.post<ApiResult<unknown>>(
    '/clinic/clinic-doctor-user',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改分销商用户记录表
 */
export async function updateClinicDoctorUser(data: ClinicDoctorUser) {
  const res = await request.put<ApiResult<unknown>>(
    '/clinic/clinic-doctor-user',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除分销商用户记录表
 */
export async function removeClinicDoctorUser(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/clinic/clinic-doctor-user/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除分销商用户记录表
 */
export async function removeBatchClinicDoctorUser(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    '/clinic/clinic-doctor-user/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询分销商用户记录表
 */
export async function getClinicDoctorUser(id: number) {
  const res = await request.get<ApiResult<ClinicDoctorUser>>(
    '/clinic/clinic-doctor-user/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
